import java.util.*;

public class TestTreeSet
{
	public static double getValue(Object obj) throws ClassCastException
	{
		// integrate into double value
		double value;
		if (obj instanceof Byte)
		{
			value = ((Byte)obj).byteValue();
		}
		else if (obj instanceof Short)
		{
			value = ((Short)obj).shortValue();
		}
		else if (obj instanceof Integer)
		{
			value = ((Integer)obj).intValue();
		}
		else if (obj instanceof Long)
		{
			value = ((Long)obj).longValue();
		}
		else if (obj instanceof Float)
		{
			value = ((Float)obj).floatValue();
		}
		else if (obj instanceof Double)
		{
			value = ((Double)obj).doubleValue();
		}
		else
		{
			// if obj is not wrapped, throw an exception
			throw new ClassCastException();
		}
		return value;
	}
	
	public static void main(String[] args)
	{
		TreeSet set = new TreeSet(
		// set an anonymous Comparator implementation
		new Comparator()
		{
			public int compare(Object o1, Object o2)
			{
				double value1 = getValue(o1);
				double value2 = getValue(o2);
				if (value1 < value2)
				{
					return -1;
				}
				else if (value1 > value2)
				{
					return 1;
				}
				else
				{
					return 0;
				}
			}
			
			public boolean equals(Object o1, Object o2)
			{
				double value1 = getValue(o1);
				double value2 = getValue(o2);
				if (value1 == value2)
				{
					return true;
				}
				else
				{
					return false;
				}
			}
		}
		);
		// add various values wrapped by objects
		set.add(new Integer(10));
		set.add(new Double(30.0));
		set.add(new Byte((byte)100));
		set.add(new Float(5000.0F));
		set.add(new Long(1L));
		set.add(new Short((short)3000));
		
		// print ordered objects for check-out
		for (Iterator i = set.iterator(); i.hasNext(); )
		{
			System.out.println(i.next());
		}
	}
}
